Index: trunk/LMDZ.TITAN/libf/muphytitan/mm_clouds.f90
===================================================================
--- trunk/LMDZ.TITAN/libf/muphytitan/mm_clouds.f90	(revision 3082)
+++ trunk/LMDZ.TITAN/libf/muphytitan/mm_clouds.f90	(revision 3083)
@@ -1,21 +1,21 @@
-! Copyright 2013-2015,2017 Université de Reims Champagne-Ardenne 
-! Contributor: J. Burgalat (GSMA, URCA)
+! Copyright 2013-2015,2017,2022 Université de Reims Champagne-Ardenne
+! Contributors: J. Burgalat (GSMA, URCA), B. de Batz de Trenquelléon (GSMA, URCA)
 ! email of the author : jeremie.burgalat@univ-reims.fr
-! 
+!
 ! This software is a computer program whose purpose is to compute
 ! microphysics processes using a two-moments scheme.
-! 
+!
 ! This library is governed by the CeCILL-B license under French law and
-! abiding by the rules of distribution of free software.  You can  use, 
+! abiding by the rules of distribution of free software.  You can  use,
 ! modify and/ or redistribute the software under the terms of the CeCILL-B
 ! license as circulated by CEA, CNRS and INRIA at the following URL
-! "http://www.cecill.info". 
-! 
+! "http://www.cecill.info".
+!
 ! As a counterpart to the access to the source code and  rights to copy,
 ! modify and redistribute granted by the license, users are provided only
 ! with a limited warranty  and the software's author,  the holder of the
 ! economic rights,  and the successive licensors  have only  limited
-! liability. 
-! 
+! liability.
+!
 ! In this respect, the user's attention is drawn to the risks associated
 ! with loading,  using,  modifying and/or developing or reproducing the
@@ -25,8 +25,8 @@
 ! professionals having in-depth computer knowledge. Users are therefore
 ! encouraged to load and test the software's suitability as regards their
-! requirements in conditions enabling the security of their systems and/or 
-! data to be ensured and,  more generally, to use and operate it in the 
-! same conditions as regards security. 
-! 
+! requirements in conditions enabling the security of their systems and/or
+! data to be ensured and,  more generally, to use and operate it in the
+! same conditions as regards security.
+!
 ! The fact that you are presently reading this means that you have had
 ! knowledge of the CeCILL-B license and that you accept its terms.
@@ -35,10 +35,11 @@
 !! summary: Clouds microphysics module
 !! author: J. Burgalat
-!! date: 2013-2015,2017
+!! date: 2013-2015,2017,2022
+!! corrections: B. de Batz de Trenquelléon (2023)
 
 MODULE MM_CLOUDS
   !! Clouds microphysics module.
   !!
-  !! The module contains all definitions of the microphysics processes related to clouds: 
+  !! The module contains all definitions of the microphysics processes related to clouds:
   !!
   !! - [nucleation](page/clouds.html#nucleation)
@@ -46,12 +47,12 @@
   !! - [sedimentation](page/clouds.html#sedimentation)
   !!
-  !! 
-  !! The interface methods always use the global variables defined in [[mm_globals(module)]] when values 
-  !! (any kind, temperature, pressure, moments...) over the vertical grid are required.
-  !! Consequently, all these functions only deals with output argument which are most of the time the 
+  !!
+  !! The interface methods always use the global variables defined in [[mm_globals(module)]] when values
+  !! (temperature, pressure, moments...) over the vertical grid are required.
+  !! Consequently, all these functions only deal with output arguments which are most of the time the
   !! tendencies of relevant variables on the atmospheric column.
   !!
-  !! @note 
-  !! Tendencies returned by public methods are always defined from  __TOP__ of the atmosphere to the 
+  !! @note
+  !! Tendencies returned by public methods are always defined from  __TOP__ of the atmosphere to the
   !! __GROUND__.
   USE MM_MPREC
@@ -62,7 +63,7 @@
   PRIVATE
 
-  PUBLIC :: mm_cloud_microphysics, mm_cloud_sedimentation, mm_cloud_nucond 
-
-  CONTAINS
+  PUBLIC :: mm_cloud_microphysics, mm_cloud_sedimentation, mm_cloud_nucond
+
+CONTAINS
 
   !============================================================================
@@ -73,27 +74,27 @@
     !! Get the evolution of moments tracers through clouds microphysics processes.
     !!
-    !! The subroutine is a wrapper to the clouds microphysics methods. It computes the tendencies of moments 
+    !! The subroutine is a wrapper to the clouds microphysics methods. It computes the tendencies of moments
     !! tracers for nucleation, condensation and sedimentation processes for the atmospheric column.
     !!
-    !! @note 
-    !! Both __dm3i__ and __dgazs__ are 2D-array with the vertical layers in first dimension and the number 
-    !! of ice components in the second. 
+    !! @note
+    !! Both __dm3i__ and __dgazs__ are 2D-array with the vertical layers in first dimension and the number
+    !! of ice components in the second.
     REAL(kind=mm_wp), DIMENSION(:), INTENT(out)   :: dm0a
-      !! Tendency of the 0th order moment of the aerosols (fractal mode) (\(m^{-3}\)). 
+    !! Tendency of the 0th order moment of the aerosols (fractal mode) (\(m^{-3}\)).
     REAL(kind=mm_wp), DIMENSION(:), INTENT(out)   :: dm3a
-      !! Tendency of the 3rd order moment of the aerosols distribution (fractal mode) (\(m^{3}.m^{-3}\)) .
+    !! Tendency of the 3rd order moment of the aerosols distribution (fractal mode) (\(m^{3}.m^{-3}\)) .
     REAL(kind=mm_wp), DIMENSION(:), INTENT(out)   :: dm0n
-      !! Tendency of the 0th order moment of the aerosols distribution (fractal mode) (\(m^{-3}\)).
+    !! Tendency of the 0th order moment of the ccn distribution (\(m^{-3}\)).
     REAL(kind=mm_wp), DIMENSION(:), INTENT(out)   :: dm3n
-      !! Tendency of the 3rd order moment of the ccn distribution (\(m^{3}.m^{-3}\)).
+    !! Tendency of the 3rd order moment of the ccn distribution (\(m^{3}.m^{-3}\)).
     REAL(kind=mm_wp), DIMENSION(:,:), INTENT(out) :: dm3i
-      !! Tendencies of the 3rd order moments of each ice components (\(m^{3}.m^{-3}\)). 
+    !! Tendencies of the 3rd order moments of each ice components (\(m^{3}.m^{-3}\)).
     REAL(kind=mm_wp), DIMENSION(:,:), INTENT(out) :: dgazs
-      !! Tendencies of each condensible gaz species (\(mol.mol^{-1}\)). 
-    REAL(kind=mm_wp), DIMENSION(:), ALLOCATABLE   :: zdm0n,zdm3n 
+    !! Tendencies of each condensible gaz species (\(mol.mol^{-1}\)).
+    REAL(kind=mm_wp), DIMENSION(:), ALLOCATABLE   :: zdm0n,zdm3n
     REAL(kind=mm_wp), DIMENSION(:,:), ALLOCATABLE :: zdm3i
     INTEGER                                    :: i
-    dm0a = 0._mm_wp ; dm3a = 0._mm_wp 
-    dm0n = 0._mm_wp ; dm3n = 0._mm_wp 
+    dm0a = 0._mm_wp ; dm3a = 0._mm_wp
+    dm0n = 0._mm_wp ; dm3n = 0._mm_wp
     dm3i = 0._mm_wp ; dgazs = 0._mm_wp
 
@@ -108,12 +109,13 @@
       call mm_cloud_sedimentation(zdm0n,zdm3n,zdm3i)
 
-      ! computes precipitations / ice fluxes
+      ! computes precipitation, settling velocity and flux of ices
       mm_ccn_prec = SUM(zdm3n*mm_dzlev)
-      mm_ccn_flux(:) = get_mass_flux(mm_rhoaer,mm_m3ccn(:)) 
-
-      DO i=1, mm_nesp 
+      mm_ccn_w(:) = wsettle(mm_play,mm_temp,mm_zlay,mm_drho,mm_drad)
+      mm_ccn_flux(:) = get_mass_flux(mm_rhoaer,mm_m3ccn(:))
+
+      DO i=1, mm_nesp
         mm_ice_prec(i) = SUM(zdm3i(:,i)*mm_dzlev)
-        mm_ice_fluxes(:,i) = get_mass_flux(mm_xESPS(i)%rho,mm_m3ice(:,i)) 
-      ENDDO 
+        mm_ice_fluxes(:,i) = get_mass_flux(mm_xESPS(i)%rho,mm_m3ice(:,i))
+      ENDDO
       ! updates tendencies
       dm0n = dm0n + zdm0n
@@ -131,28 +133,36 @@
     !! Get moments tendencies through nucleation/condensation/evaporation.
     !!
-    !! The method is a wrapper of [[mm_clouds(module):nc_esp(subroutine)]] which computes the 
+    !! The method is a wrapper of [[mm_clouds(module):nc_esp(subroutine)]] which computes the
     !! tendencies of tracers for all the condensible species given in the vector __xESPS__.
     !!
+    !! Aerosols and CCN distribution evolution depends on the ice components:
+    !!   - For nucleation only creation of CCN can occur.
+    !!   - For condensation only loss of CCN can occur.
+    !!
+    !! We use the simple following rule to compute the variation of CCN and aerosols:
+    !! The global variation of CCN (and thus aerosols) is determined from the most intense activity
+    !! of the ice components.
+    !!
     !! @warning
-    !! __xESPS__, __m3i__ and __gazes__ must share the same indexing. For example if __xESPS(IDX)__ 
-    !! corresponds to \(CH_{4}\) properties then __m3i(IDX)__ must be the total volume of solid 
+    !! __xESPS__, __m3i__ and __gazes__ must share the same indexing. For example if __xESPS(IDX)__
+    !! corresponds to \(CH_{4}\) properties then __m3i(IDX)__ must be the total volume of solid
     !! \(CH_{4}\) (ice) and  __gazs(IDX)__ its vapor mole fraction.
     REAL(kind=mm_wp), DIMENSION(:), INTENT(out)   :: dm0a
-      !! Tendency of the 0th order moment of the aerosols (fractal mode) (\(m^{-3}\)).
+    !! Tendency of the 0th order moment of the aerosols (fractal mode) (\(m^{-3}\)).
     REAL(kind=mm_wp), DIMENSION(:), INTENT(out)   :: dm3a
-      !! Tendency of the 3rd order moment of the aerosols distribution (fractal mode) (\(m^{3}.m^{-3}\)). 
+    !! Tendency of the 3rd order moment of the aerosols distribution (fractal mode) (\(m^{3}.m^{-3}\)).
     REAL(kind=mm_wp), DIMENSION(:), INTENT(out)   :: dm0n
-      !! Tendency of the 0th order moment of the aerosols distribution (fractal mode) (\(m^{-3}\)).
+    !! Tendency of the 0th order moment of the aerosols distribution (fractal mode) (\(m^{-3}\)).
     REAL(kind=mm_wp), DIMENSION(:), INTENT(out)   :: dm3n
-      !! Tendency of the 3rd order moment of the ccn distribution (\(m^{3}.m^{-3}\)).
+    !! Tendency of the 3rd order moment of the ccn distribution (\(m^{3}.m^{-3}\)).
     REAL(kind=mm_wp), DIMENSION(:,:), INTENT(out) :: dm3i
-      !! Tendencies of the 3rd order moments of each ice components (\(m^{3}.m^{-3}\)).
+    !! Tendencies of the 3rd order moments of each ice components (\(m^{3}.m^{-3}\)).
     REAL(kind=mm_wp), DIMENSION(:,:), INTENT(out) :: dgazs
-      !! Tendencies of each condensible gaz species (\(mol.mol^{-1}\)) .
+    !! Tendencies of each condensible gaz species (\(mol.mol^{-1}\)) .
     REAL(kind=mm_wp), DIMENSION(:,:), INTENT(out) :: gazsat
-      !! Saturation ratio of each condensible specie.
-    INTEGER                                   :: i,idx,ng
-    TYPE(mm_esp)                                 :: xESP
+    !! Saturation ratio of each condensible specie.
+    INTEGER                                       :: i,idx
     REAL(kind=mm_wp), DIMENSION(:,:), ALLOCATABLE :: zdm0a,zdm3a,zdm0n,zdm3n
+
     ALLOCATE(zdm0a(mm_nla,mm_nesp),zdm3a(mm_nla,mm_nesp), &
              zdm0n(mm_nla,mm_nesp),zdm3n(mm_nla,mm_nesp))
@@ -164,24 +174,24 @@
     ENDDO
 
-    ! Computes balance :
-    ! Each ice components has been treated independently from the others, and
-    ! their tendencies are returned as is (just converted in input units).
-    !
-    ! Aerosols and CCN distribution evolution depends on the ice components:
-    !   - For nucleation only creation of CCN can occur.
-    !   - For condensation only loss of CCN can occur.
-    ! We use the simple following rule :
-    !   The global variation of CCN (and thus aerosols) is determined from the
-    !   most intense activity of the ice components.
-    !   that is the maximum value of the CCN tendencies regardless of its sign.
     DO i=1, mm_nla
-      idx = MAXLOC(zdm0n(i,:),DIM=1) ! WARNING this is not the definition above (should be in ABS() func)
-      dm0n(i) = zdm0n(i,idx)
-      dm3n(i) = zdm3n(i,idx)
-      dm0a(i) = zdm0a(i,idx)
-      dm3a(i) = zdm3a(i,idx)
-      ! all ice are returned but we must convert their units
-      dm3i(i,:) = dm3i(i,:)
+      ! retrieve the index of the maximum tendency of CCN where ice variation is not null.
+      idx = MAXLOC(zdm0n(i,:),DIM=1,MASK=(dm3i(i,:) /= 0._mm_wp .OR. mm_m3ice(i,:)+dm3i(i,:) >= 0._mm_wp))
+      IF (idx == 0) THEN
+        dm0n(i) = 0._mm_wp
+        dm3n(i) = 0._mm_wp
+        dm0a(i) = 0._mm_wp
+        dm3a(i) = 0._mm_wp
+      ELSE
+        IF (mm_debug .AND. ABS(zdm0n(i,idx)) > 1e3) THEN
+          WRITE(*,'((a),I2.2,(a),ES10.3,(a))') "Z(",i,") = ",mm_play(i)*1e2, &
+            " mbar: Max aer/ccn exchange variation due to specie: "//TRIM(mm_xESPS(idx)%name)
+        ENDIF
+        dm0n(i) = zdm0n(i,idx)
+        dm3n(i) = zdm3n(i,idx)
+        dm0a(i) = zdm0a(i,idx)
+        dm3a(i) = zdm3a(i,idx)
+      ENDIF
     ENDDO
+
   END SUBROUTINE mm_cloud_nucond
 
@@ -189,67 +199,112 @@
     !! Get moments tendencies through nucleation/condensation/evaporation of a given condensible specie.
     !!
-    !! The method computes the global tendencies of the aerosols, ccn and "ice" moments through cloud 
+    !! The method computes the global tendencies of the aerosols, ccn and "ice" moments through cloud
     !! microphysics processes (nucleation & condensation).
     !!
     !! @warning
-    !! Input quantities __m3iX__,__m3iO__, __m0aer__,__m3aer__, __m0ccn__,__m3ccn__ are assumed to be in 
-    !! \(X.kg^{-1}\) (where X is the unit of the moment that is, a number for M0 and a volume - \(m^3\) 
+    !! Input quantities __m3iX__,__m3iO__, __m0aer__,__m3aer__, __m0ccn__,__m3ccn__ are assumed to be in
+    !! \(X.m^{-3}\) (where X is the unit of the moment that is, a number for M0 and a volume - \(m^3\)
     !! for M3) ; __vapX__ must be expressed in term of molar fraction.
     TYPE(mm_esp), INTENT(in)                   :: xESP
-      !! Condensate specie properties.
+    !! Condensate specie properties.
     REAL(kind=mm_wp),INTENT(in), DIMENSION(:)  :: vapX
-      !! Gas specie molar fraction on the vertical grid from __TOP__ to __GROUND__ (\(mol.mol^{-1}\)).
+    !! Gas specie molar fraction on the vertical grid from __TOP__ to __GROUND__ (\(mol.mol^{-1}\)).
     REAL(kind=mm_wp),INTENT(in), DIMENSION(:)  :: m3iX
-      !! 3rd order moment of the ice component (\(m^{3}.m^{-3}\)).
+    !! 3rd order moment of the ice component (\(m^{3}.m^{-3}\)).
     REAL(kind=mm_wp),INTENT(out), DIMENSION(:) :: dvapX
-      !! Tendency of gas specie (\(mol.mol^{-1}\)).
+    !! Tendency of gas specie (\(mol.mol^{-1}\)).
     REAL(kind=mm_wp),INTENT(out), DIMENSION(:) :: dm3iX
-      !! Tendency of the 3rd order moment of the ice component (\(m^{3}.m^{-3}\)).
+    !! Tendency of the 3rd order moment of the ice component (\(m^{3}.m^{-3}\)).
     REAL(kind=mm_wp),INTENT(out), DIMENSION(:) :: dm0aer
-      !! Tendency of the 0th order moment of the fractal mode distribution (\(m^{-3}\)).
+    !! Tendency of the 0th order moment of the fractal mode distribution (\(m^{-3}\)).
     REAL(kind=mm_wp),INTENT(out), DIMENSION(:) :: dm3aer
-      !! Tendency of the 3rd order moment of the fractal mode distribution (\(m^{3}.m^{-3}\)).
+    !! Tendency of the 3rd order moment of the fractal mode distribution (\(m^{3}.m^{-3}\)).
     REAL(kind=mm_wp),INTENT(out), DIMENSION(:) :: dm0ccn
-      !! Tendency of the 0th order moment of the ccn distribution (\(m^{-3}\)).
+    !! Tendency of the 0th order moment of the ccn distribution (\(m^{-3}\)).
     REAL(kind=mm_wp),INTENT(out), DIMENSION(:) :: dm3ccn
-      !! Tendency of the 3rd order moment of the ccn distribution (\(m^{3}.m^{-3}\)).
+    !! Tendency of the 3rd order moment of the ccn distribution (\(m^{3}.m^{-3}\)).
     REAL(kind=mm_wp),INTENT(out), DIMENSION(:) :: Xsat
-      !! Saturation ratio values on the vertical grid (--).
+    !! Saturation ratio values on the vertical grid (--).
     INTEGER                                 :: i
     REAL(kind=mm_wp)                        :: bef,aft
     REAL(kind=mm_wp), DIMENSION(SIZE(vapX)) :: sm0a,sm3a,sm0n,sm3n,sm3iX
     REAL(kind=mm_wp), DIMENSION(SIZE(vapX)) :: zm0a,zm3a,zm0n,zm3n,zm3iX,zvapX
-    REAL(kind=mm_wp), DIMENSION(SIZE(vapX)) :: pX,sig,qsat,lheat,seq,up,down, &
-                                               ctot,newvap,nucr,grate,cm0,cm3
-    ! Initialization : 
-    ! Copy input argument and convert units X.m-3 -> X.kg-1) 
+    REAL(kind=mm_wp), DIMENSION(SIZE(vapX)) :: pX,sig,qsat,seq,up,down,ctot,newvap,nucr,grate,cm0,cm3,drad
+
+    ! get a copy of drop radius.
+    drad(:) = mm_drad(:)
+
+    ! Initialization :
+    ! Copy input argument and convert units X.m-3 -> X.kg-1
     ! sXXX is the initial converted value saved
-    sm3iX = m3iX/mm_rhoair 
+    sm3iX = m3iX/mm_rhoair
     sm0a = mm_m0aer_f/mm_rhoair ; sm3a = mm_m3aer_f/mm_rhoair
     sm0n = mm_m0ccn/mm_rhoair ; sm3n = mm_m3ccn/mm_rhoair
     ! zXXX is our working copy
-    zm3ix = sm3ix ; zm0a = sm0a ; zm3a = sm3a ; zm0n = sm0n ; zm3n = sm3n
-
-    ! Molar fraction of X specie is set in mass mixing ratio 
+    zm3iX = sm3iX ; zm0a = sm0a ; zm3a = sm3a ; zm0n = sm0n ; zm3n = sm3n
+
+    ! Molar fraction of X specie is set in mass mixing ratio [kg.kg-1]
     zvapX  = vapX  * xESP%fmol2fmas
-    ! Surface tension
+    ! Surface tension [N.m-1]
     sig = mm_sigX(mm_temp,xESP)
-    ! X specie mass mixing ratio at saturation
-    qsat = mm_qsatX(mm_temp,mm_play,xESP)
+    ! X specie mass mixing ratio at saturation [kg.kg-1]
+    qsat = mm_ysatX(mm_temp,mm_play,xESP) * xESP%fmol2fmas
     ! partial pressure of X specie
     pX = vapX * mm_play
     ! Saturation ratio
     Xsat = zvapX / qsat
-    ! Equilibrium saturation near the drop 
-    seq = dexp(2._mm_wp*sig*xESP%masmol/(xESP%rho*mm_rgas*mm_temp*mm_drad))
-    ! Latent heat released
-    lheat = mm_lheatX(mm_temp,xESP)
+    
     ! Gets nucleation rate (ccn radius is the monomer !)
     call nuc_rate((/(mm_rm, i=1,mm_nla)/),mm_temp,xESP,pX,Xsat,nucr)
+    ! IMPORTANT: update CCN and aerosols moment from nucleation NOW !
+    ! Doing so should prevent a nasty bug that occurs if we want to generate clouds from scratch (i.e. a "dry" atmosphere without any clouds tracers already present).
+    !
+    ! In such case, we do not produce ice variation on the first call of the method, at most only CCN are produced (i.e. dm3i == 0, dm3n != 0)
+    ! But the rules for computing the global tendencies in mm_cloud_nucond state that the global variation for CCN is due to the most active specie exchange.
+    !
+    ! for nucleation we have the following equations:
+    !   dMa(k)/dt = - dMn(k)/dt (conservation of aerosols+ccn)           (1)
+    !   dMa(k)/dt = - 4*PI*nucr/rm * Ma(k+3)                             (2)
+    !             = - 4*PI*nucr/rm * alpha(k+3)/alpha(k) * rc**3 * Ma(k)
+    ! With:
+    !   - Ma(k): k-th order moment of aerosol
+    !   - Mn(k): k-th order moment of ccn
+    !   - nucr : the nucleation rate.
+    ! We solve (implicit scheme) :
+    !   CST_M(k) = 4*PI*nucr/rm * alpha(k+3)/alpha(k)*rc**3 * dt
+    !   Ma(k)[t+dt] = 1/(1+CST_M(k)) * Ma(k)[t]                          (3)
+    ! Then, from eq. 2:
+    ! Mn(k)[t+dt] = Mn(k)[t] + CST_M(k)/(1+CST_M(k))*Ma(k)[t]            (4)
+    cm0 = 4._mm_wp*mm_pi*nucr/mm_rm*mm_alpha_f(3._mm_wp)*mm_rcf**3*mm_dt
+    cm3 = 4._mm_wp*mm_pi*nucr/mm_rm*mm_alpha_f(6._mm_wp)/mm_alpha_f(3._mm_wp)*mm_rcf**3*mm_dt
+    zm0a = 1._mm_wp/(1._mm_wp+cm0) * zm0a
+    zm3a = 1._mm_wp/(1._mm_wp+cm3) * zm3a
+    WHERE (zm0a <= 0._mm_wp .OR. zm3a <= 0._mm_wp)
+      zm0a = 0._mm_wp
+      zm3a = 0._mm_wp
+      zm0n = zm0n + sm0a
+      zm3n = zm3n + sm3a
+    ELSEWHERE
+      zm0n = zm0n + cm0*zm0a
+      zm3n = zm3n + cm3*zm3a
+    ENDWHERE
+
+    ! update the drop radius (we probably should recompute totally the radius to be in better agreement with the other moments)
+    ! We must manage the case where there is no ices and no ccn ==> drop radius is ZERO,
+    ! but conditions are met to spawn nucleation process: creation of ccn.
+    ! Then we set the drop radius to the monomer radius.
+    !
+    ! Doing so will prevent a nasty bug to occur later when ice volume is updated !
+    WHERE (nucr > 0._mm_wp .AND. drad <= mm_drad_min)
+      drad = mm_rm
+    ENDWHERE
+
+    ! Equilibrium saturation near the drop
+    seq = exp(min(30._mm_wp,2._mm_wp*sig*xESP%masmol/(xESP%rho*mm_rgas*mm_temp*drad)))
     ! Gets growth rate
-    call growth_rate(mm_temp,mm_play,pX/Xsat,xESP,seq,mm_drad,grate)
-    ctot = zvapx + xESP%rho * m3iX
-    up = vapx + mm_dt * grate * 4._mm_wp * mm_pi * xESP%rho * mm_drad * seq * zm0n
-    down = 1._mm_wp + mm_dt * grate * 4._mm_wp * mm_pi * xESP%rho * mm_drad / qsat * zm0n
+    call growth_rate(mm_temp,mm_play,pX/Xsat,xESP,seq,drad,grate)
+    ctot = zvapx + xESP%rho * zm3iX
+    up = zvapx + mm_dt * grate * 4._mm_wp * mm_pi * xESP%rho * drad * seq * zm0n
+    down = 1._mm_wp + mm_dt * grate * 4._mm_wp * mm_pi * xESP%rho * drad / qsat * zm0n
     ! gets new vapor X specie mass mixing ratio : cannot be greater than the
     ! total gas + ice and lower than nothing :)
@@ -257,94 +312,57 @@
     ! gets "true" growth rate
     grate = grate * (newvap/qsat - seq)
-    
+
     ! computes tendencies through condensation
-    ! 1) check for the specific case : NO ICE and SUBLIMATION
-    WHERE (zm3iX <= 0._mm_wp .AND. grate <= 0._mm_wp) 
-      ! no ice and sublimation : reset ice to 0
-      zm3iX = 0._mm_wp
-    ELSEWHERE
-      ! update ice volume ...
-      zm3iX = zm3iX + mm_dt*grate*4._mm_wp*mm_pi*mm_drad*zm0n
-      ! ... and check if there ice left in the ccn
-      WHERE (zm3ix <= 0._mm_wp)
-        zm3ix = 0._mm_wp
-        zm0a = zm0a + zm0n ; zm0n = 0._mm_wp
-        zm3a = zm3a + zm3n ; zm3n = 0._mm_wp
-      ENDWHERE
-    ENDWHERE
-    
-    ! computes tendencies
-    ! all of these tendencies are in X.kg-1
-    dm0aer = zm0a - sm0a
-    dm3aer = zm3a - sm3a
-    dm0ccn = zm0n - sm0n
-    dm3ccn = zm3n - sm3n
-    dm3ix  = zm3ix - sm3ix
-    ! and this one is in mol.mol-1
-    dvapx  = -xESP%rho * dm3ix / xESP%fmol2fmas
-
-    ! reset temporary arrays to initial values
-    zm3ix = sm3ix ; zm0a = sm0a ; zm3a = sm3a ; zm0n = sm0n ; zm3n = sm3n
-  
-    ! Computes global tendencies (nucleation && condensation)
-    !
-    ! for nucleation we have the following equations:
-    !   dMaer_(k)/dt = - dMccn_(k)/dt (conservation of aerosols+ccn)       (1)
-    !   dMaer_(k)/dt = - 4*PI*nucr/rm * Maer_(k+3)                         (2)
-    !                = - 4*PI*nucr/rm * alpha(k+3)/alpha(k) * Maer_(k)
-    !   where alpha(k+3) = Maer_(k+3)/Maer_(0) /  rc**(k+3)
-    ! We solve (implicit scheme) :
-    !   CONST_M(k) = 4*PI*nucr/rm * alpha(k+3)/alpha(k)*rc**3 * dt
-    !   Maer_(k)[t+dt] = 1/(1+CONST_M(k)) * Maer_(k)[t]                    (3)
-    ! Then, from eq. 2:
-    ! Mccn_(k)[t+dt] = Mccn_(k)[t] + CONST_M(k)/(1+CONST_M(k))*Maer_(k)[t] (4)
-    ! 
-    cm0 = 4._mm_wp*mm_pi*nucr/mm_rm*mm_alpha_f(3._mm_wp)*mm_rcf**3*mm_dt
-    cm3 = 4._mm_wp*mm_pi*nucr/mm_rm*mm_alpha_f(6._mm_wp)/mm_alpha_f(3._mm_wp)*mm_rcf**3*mm_dt
-    zm0a = 1._mm_wp/(1._mm_wp+cm0) * zm0a
-    zm3a = 1._mm_wp/(1._mm_wp+cm0) * zm3a
-    WHERE (zm0a <= 0._mm_wp .OR. zm3a <= 0._mm_wp) 
-      zm0a=0._mm_wp
-      zm3a=0._mm_wp
-      zm0n = zm0n + sm0a
-      zm3n = zm3n + sm3a
-    ELSEWHERE
-      zm0n = zm0n + cm0/(1.+cm0)*zm0a
-      zm3n = zm3n + cm3/(1.+cm3)*zm3a
-    ENDWHERE
-  
-    ! Adds condensation tendencies
-    zm0a = zm0a + dm0aer
-    zm3a = zm3a + dm3aer
-    zm0n = zm0n + dm0ccn
-    zm3n = zm3n + dm3ccn
+    DO i=1,mm_nla
+      ! check for the specific case : NO ICE and SUBLIMATION
+      IF (zm3iX(i) <= 0._mm_wp .AND. grate(i) <= 0._mm_wp) THEN
+        zm3iX(i) = 0._mm_wp
+      ELSE
+        ! update ice volume ...
+        zm3iX(i) = zm3iX(i) + mm_dt*grate(i)*4._mm_wp*mm_pi*drad(i)*zm0n(i)
+        ! ... and check if there is ice left in the ccn
+        IF (zm3iX(i) <= 0._mm_wp) THEN
+          zm3iX(i) = 0._mm_wp
+          zm0a(i) = zm0a(i) + zm0n(i) ; zm0n(i) = 0._mm_wp
+          zm3a(i) = zm3a(i) + zm3n(i) ; zm3n(i) = 0._mm_wp
+        ENDIF
+      ENDIF
+    ENDDO
 
     ! Computes balance
     IF (mm_debug) THEN
-      WRITE(*,'(a)') "Condensation/nucleation balance :"
       DO i=1,mm_nla
         bef = sm0a(i) + sm0n(i)
         aft = zm0a(i)  + zm0n(i)
-        IF (ABS(bef-aft)/bef > 1e-10_mm_wp) WRITE(*,'((a),I2.2,(a))') &
-        "[WARNING] nc_esp speaking: Total number not conserved (z=",i,")"
+        IF (ABS(bef-aft)/bef > 1e-10_mm_wp) THEN
+          WRITE(*,'((a),I2.2,(a),ES20.12,(a),ES20.12)') &
+            "[DEBUG] nc_esp("//TRIM(xESP%name)//"): M0 not conserved (z=",i,")",bef," <-> ",aft
+        ENDIF
         bef = sm3a(i) + sm3n(i)
         aft = zm3a(i)  + zm3n(i)
-        IF (ABS(bef-aft)/bef > 1e-10_mm_wp) WRITE(*,'((a),I2.2,(a))') &
-        "[WARNING] nc_esp speaking: Total volume not conserved (z=",i,")"
+        IF (ABS(bef-aft)/bef > 1e-10_mm_wp) THEN
+          WRITE(*,'((a),I2.2,(a),ES20.12,(a),ES20.12)') &
+            "[DEBUG] nc_esp("//TRIM(xESP%name)//"): M3 not conserved (z=",i,")",bef," <-> ",aft
+        ENDIF
       ENDDO
     ENDIF
 
-    ! Now updates tendencies
-    dm0aer = (zm0a-sm0a)*mm_rhoair
-    dm3aer = (zm3a-sm3a)*mm_rhoair
-    dm0ccn = (zm0n-sm0n)*mm_rhoair
-    dm3ccn = (zm3n-sm3n)*mm_rhoair
+    ! compute tendencies:
+    ! all of these tendencies are in X.m-3 !
+    dm0aer = (zm0a - sm0a)*mm_rhoair
+    dm3aer = (zm3a - sm3a)*mm_rhoair
+    dm0ccn = (zm0n - sm0n)*mm_rhoair
+    dm3ccn = (zm3n - sm3n)*mm_rhoair
+
+    dm3iX  = (zm3iX - sm3iX)                    ! this one in X.kg-1 (temporary) !
+    dvapX  = -xESP%rho * dm3iX / xESP%fmol2fmas ! in order to compute this one in mol.mol-1
+    dm3iX  = dm3iX*mm_rhoair                    ! update ice tendencies in X.m-3 !
 
   END SUBROUTINE nc_esp
-  
+
   SUBROUTINE nuc_rate(rccn,temp,xESP,pvp,sat,rate)
     !! Get nucleation rate.
     !!
-    !! The method computes the heterogeneous nucleation rate for the given specie on a fractal particle 
+    !! The method computes the heterogeneous nucleation rate for the given specie on a fractal particle
     !! of size __rccn__.
     !! Except __xESP__, all arguments are vectors of the same size (vertical grid).
@@ -355,32 +373,29 @@
     TYPE(mm_esp), INTENT(in)                    :: xESP !! X specie properties (--).
     REAL(kind=mm_wp), INTENT(out), DIMENSION(:) :: rate !! The nucleation rate (\(m^-{2}.s^{-1}\)).
-    INTEGER                                 :: nv
-    REAL(kind=mm_wp), DIMENSION(:), ALLOCATABLE :: nX,rstar,gstar,x,zeldov,deltaf, &
-                                               fsh,fstar,sig
-    nv = SIZE(rccn)
-    ALLOCATE(nX(nv), rstar(nv), gstar(nv), x(nv), zeldov(nv), &
-             deltaf(nv), fsh(nv), fstar(nv))
+    INTEGER          :: i
+    REAL(kind=mm_wp) :: r,t,s,sig,nX,rstar,gstar,x,zeldov,deltaf,fsh,fstar
+
+    rate(:) = 0._mm_wp
     ! Activation condition
-    WHERE (sat > 1._mm_wp)
-      sig = mm_sigX(temp,xESP)
-      nX    = pvp/mm_kboltz/temp
-      rstar = 2._mm_wp*sig*xESP%vol/(mm_kboltz*temp*dlog(sat))
-      ! curvature radius
-      x     = rccn/rstar
-      fsh   = mm_fshape(xESP%mteta,x)
-      fstar = (4._mm_wp/3._mm_wp*mm_pi)*sig*(rstar**2.)*fsh
-      deltaf=MIN(MAX((2.*mm_fdes-mm_fdif-fstar)/(mm_kboltz*temp),-100._mm_wp),100._mm_wp)
-      WHERE (deltaf == -100._mm_wp) 
-        rate = 0._mm_wp
-      ELSEWHERE
-        gstar  = 4._mm_wp*mm_pi*(rstar**3)/(3._mm_wp*xESP%vol)
-        zeldov = dsqrt(fstar/(3._mm_wp*mm_pi*mm_kboltz*temp*(gstar**2)))
-        rate   = zeldov*mm_kboltz*temp*(nX*rstar)**2._mm_wp*dexp(deltaf)/ &
-                  (fsh*mm_nus*xESP%mas)
-      ENDWHERE
-    ELSEWHERE
-      rate = 0._mm_wp
-    ENDWHERE
-    DEALLOCATE(nX,rstar,gstar,x,zeldov,deltaf,fsh,fstar)
+    DO i=1, SIZE(rccn)
+      s = sat(i)
+      IF (s > 1._mm_wp) THEN
+        t = temp(i) ; r = rccn(i)
+        sig = mm_sigX(t,xESP)
+        nX    = pvp(i)/mm_kboltz/t
+        rstar = 2._mm_wp*sig*xESP%vol/(mm_kboltz*t*dlog(s))
+        ! curvature radius
+        x     = r/rstar
+        fsh   = mm_fshape(xESP%mteta,x)
+        fstar = (4._mm_wp*mm_pi/3._mm_wp)*sig*(rstar**2.)*fsh
+        deltaf=MIN(MAX((2.*mm_fdes-mm_fdif-fstar)/(mm_kboltz*t),-100._mm_wp),100._mm_wp)
+        IF (deltaf > -100._mm_wp) THEN
+          gstar  = 4._mm_wp*mm_pi*(rstar**3)/(3._mm_wp*xESP%vol)
+          zeldov = dsqrt(fstar/(3._mm_wp*mm_pi*mm_kboltz*t*(gstar**2)))
+          rate(i)= zeldov*mm_kboltz*t*(nX*rstar)**2._mm_wp*dexp(deltaf)/(fsh*mm_nus*xESP%mas)
+        ENDIF
+      ENDIF
+    ENDDO
+
     RETURN
   END SUBROUTINE nuc_rate
@@ -390,5 +405,5 @@
     !!
     !! The method computes the growth rate a drop through condensation/evaporation processes:
-    !! 
+    !!
     !! $$ r \times \frac{dr}{dt} = g_{rate} \times (S - S_{eq}) $$
     !!
@@ -396,8 +411,8 @@
     REAL(kind=mm_wp), INTENT(in), DIMENSION(:)  :: temp  !! Temperature (K).
     REAL(kind=mm_wp), INTENT(in), DIMENSION(:)  :: pres  !! Pressure level (Pa).
-    REAL(kind=mm_wp), INTENT(in), DIMENSION(:)  :: seq   !! Saturation vapor pressure of specie (Pa).
-    REAL(kind=mm_wp), INTENT(in), DIMENSION(:)  :: drad  !! Specie properties.
-    REAL(kind=mm_wp), INTENT(in), DIMENSION(:)  :: pXsat !! Equilibrium saturation near the drop.
-    TYPE(mm_esp), INTENT(in)                    :: xESP  !! Drop radius (m).
+    REAL(kind=mm_wp), INTENT(in), DIMENSION(:)  :: pXsat !! Saturation vapor pressure of specie (Pa).
+    TYPE(mm_esp), INTENT(in)                    :: xESP  !! Specie properties.
+    REAL(kind=mm_wp), INTENT(in), DIMENSION(:)  :: seq   !! Equilibrium saturation near the drop.
+    REAL(kind=mm_wp), INTENT(in), DIMENSION(:)  :: drad  !! Drop radius (m).
     REAL(kind=mm_wp), INTENT(out), DIMENSION(:) :: rate  !! Growth rate (\(m^{2}.s^{-1}\)).
     REAL(kind=mm_wp), DIMENSION(:), ALLOCATABLE :: k,knu,slf,rkc,rdc,l,dv
@@ -412,5 +427,5 @@
     ! Diffusion coefficient of X gas
     Dv(:) = 1._mm_wp/3._mm_wp*dsqrt(8._mm_wp*mm_rgas*temp(:)/(mm_pi*xESP%masmol))*mm_kboltz*temp(:) / &
-         (mm_pi*pres(:)*(mm_air_rad+xESP%ray)**2* dsqrt(1._mm_wp+xESP%fmol2fmas))
+      (mm_pi*pres(:)*(mm_air_rad+xESP%ray)**2* dsqrt(1._mm_wp+xESP%fmol2fmas))
     knu(:) = l(:)/drad(:)                                         ! The knudsen number of the drop
     slf(:) = (1.333_mm_wp+0.71_mm_wp/knu(:))/(1._mm_wp+1._mm_wp/knu(:)) ! Slip flow correction
@@ -424,5 +439,5 @@
     RETURN
   END SUBROUTINE growth_rate
- 
+
 
   !-----------------------------------------------------------------------------
